# book-bff

More detailed documentation is available here: https://mobica-workshops.gitlab.io/examples/js/vuejs/book-frontend/

## Requirements

This Project requires those tools for the development:

- **Brew** - optional
- **Docker Engine** - required
- **Docker Compose** - required
- **Ansible** - required
- **Helm** - optional
- **K3d** - optional
- **Trivy** - optional
- **Grype** - optional

and `Node.JS` installed and configured as a `JavaScript` runtime environment.

You can find how to install required tools for this service here: https://mobica-workshops.gitlab.io/documentation/requirements-guide/

## Configuration procedure

Prepare configuration:

    ./local-configure.sh

Because this is only for presentation purposes password is: `ThisIsExamplePassword4U`

By the end of running this, you should have files in the `secret` folder which will be used by all the Development
methods

## Development

### Service Development and Continuous Integration

The most standard method of development requires starting a local docker-compose file with a command:

    docker-compose -f docker-compose-local.yml up

or if you prefer mocked versions of our backend services:

    docker-compose -f docker-compose-mock.yml up

This will setup all dependent services, except one which You develop. To setup Your microservice you can use prepared shell scripts:

- `build.sh` - to build your FrontEnd app
- `serve.sh` - to serve it
- `local-test.sh` - to run integration and functional tests

### Continuous Delivery and end-to-end testing

This environment is most useful for checking application with the tools like by example Postman before sending result
of work to the repository.

You just need to start it with this command:

    docker-compose -f docker-compose-test.yml up

and you can use integrated Swagger UI, Swagger Editor and other tools which can use our OpenAPI files:

- `public/v1/openapi.json`
- `public/v1/openapi.yaml`

which we copied from book-bff project.

### Continuous Deployment Testing

Please remember to read the documentation which in detail shows how to use our `k3d` integration.

If your `K3d` and `helm` are correctly configured just run:

    ./deploy-k3s.sh

### Documentation Development

To work with documentation that is generated based on AsciiDoc files you need to have Ruby >= 3.0 installed on your
desktop.

To see generated locally version of this documentation you need to have Python >= 3.7 installed on your desktop.
Documentation will be served on port 8880

You have those scripts which automate building and serving this documentation:

    ./build-doc.sh
    ./serve-doc.sh

## Production

> Here should be a description of your production procedures.

### Readiness checklist

#### General Rules

- [ ] **No shared database between different services** - a DB instance should only be used by one service exclusively.
- [ ] **Not breaking the one-hop rule** - _“By default, a service should not call other services to respond to a request, except in exceptional circumstances.”_. The exception can be for example Backend For Frontend (like GraphQL) which can compose and aggregate data on top of other services.
- [ ] **Prefer APIs to Sharing SDKs**. Try to avoid using SDKs between the services, it is not needed.

#### Documentation

- [ ] **README.md** - self-explanatory service name, how to run it locally and domain/subdomain, bounded context described
- [ ] **Project documentation** - if possible should be kept with a code
    - [ ] **Architecture docs / [C4 Model diagrams](https://c4model.com/)**
    - [ ] **Development docs** - a more detailed version of service development documentation than **README.md** which will be used by new developers to start development of the service and for other teams to cooperate with the development team.
- [ ] **API Open Specification** file in the root directory or other location known by everyone: `openapi.yaml` file
- [ ] **API versioning** - if needed

#### Testing and Quality

- [ ] **Linters** (with reports that can be exported to e.g. SonarQube)
- [ ] **Automatic code Formatter or code Format Checkers** (e.g. gofmt, ktfmt)
- [ ] **Test coverage above 70%** (use common sense, just getting to the required number of coverage is not a goal here)
- [ ] **Functional/e2e/acceptance tests** in place
- [ ] **Load Tests** (at least basic ones) especially if higher traffic is expected
- [ ] **Contract Tests** are recommended if there is service-to-service communication via HTTP (example: [PACT tests](https://docs.pact.io/))


#### Observability

- [ ] **Logging** in general https://12factor.net/logs
    - [ ] **All logs are written to STDOUT / STDERR**.
    - [ ] **Logs are written in JSON**.
    - [ ] **No sensitive data is logged**
- [ ] **Monitoring**
    - [ ] Integration with a monitoring platforms and Dashboards in place.
    - [ ] Business metrics added to the dashboards
- [ ] **Tracing**
    - [ ] **Distributed tracing configured**
    - [ ] **Error tracking configured**
- [ ] **Alerts are configured**

#### Operations and Resiliency

- [ ] **Staging environment exists**
- [ ] There is **autoscaling** in place (based on CPU, memory, traffic, events/messages e.g. HPA with K8S)
- [ ] **Graceful shutdown**: The application understands SIGTERM and other signals and will gracefully shut down itself after processing the current task. https://12factor.net/disposability
- [ ] **Configuration via environment**: All important configuration options are read from the environment and the environment has higher priority over configuration files (but lower than the command line arguments). https://12factor.net/config
- [ ] **Health Checks**: Readiness and Liveness probes
- [ ] **Define [SLO/SLI/SLA](https://cloud.google.com/blog/products/devops-sre/sre-fundamentals-slis-slas-and-slos)**
- [ ] Build applications with **Multi-tenancy** in mind (sites, regions, users, etc.)

#### Security and Compliance

- [ ] If your service does need to be accessible through the public Internet
    - [ ] **Authentication/Authorization** in place if needed / JWT / Cognito / Auth0
    - [ ] Ensure it lives behind our Cloudfront **CDN** (and uses WAF if necessary)
- [ ] **Vulnerabilities scan check**
- [ ] **Does not violate any licenses**
- [ ] **GDPR** data not exposed (https://gdpr-info.eu/art-4-gdpr/)
- [ ] **PII data not logged or stored without any good reason** (ask your DPO) - [Best practices to avoid sending Personally Identifiable Information (PII)](https://support.google.com/adsense/answer/6156630?hl=en), Check Data Retention Policies

## Notes

### book-bff notes

The JWT authorization logic is used as verification of the accessibility of the end user to public/nonpublic backend API.
The token body implementation is defined in [app/lib/token.go](./app/lib/token.go) file.

It is not encrypted, it is encoded in Base64. The JWT is typically stored in LocalStorage or Cookies on the Frontend side, and
the verification does not require any communication between the servers and databases.

Storing data in LocalStorage at the Frontend is enabling an XSS attack.
To avoid it the JWT can be stored in Cookies, or at the front end there might be used SessionID authorization, and JWT authorization can only be done on the server -> gateway communication between other microservices.

The ideas and some proposals of good practice of the article can be obtained at this [link](https://jerrynsh.com/all-to-know-about-auth-and-cookies/#same-site-cookies).

## Known issues

### book-bff issues

The JWT is not containing **exp**(expiration) field, which is causing a security gap, in case the JWT token is stolen by Cross Site Script(**XSS**) attack.
